com.smartgwt.client.widgets.drawing

## Class DrawCurve

- java.lang.Object
- - com.smartgwt.client.core.BaseClass
  - - com.smartgwt.client.widgets.drawing.DrawItem
    - - com.smartgwt.client.widgets.drawing.DrawCurve

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers, HasClickHandlers, HasDragMoveHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseUpHandlers, HasMovedHandlers, HasResizedHandlers, HasShowContextMenuHandlers
  Direct Known Subclasses:
    DrawBlockConnector

      public class DrawCurve
      extends DrawItem

  DrawItem that renders cubic bezier curves.

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.BaseClass

      `config, configOnly, factoryCreated, factoryProperties, id, scClassName`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DrawCurve()`
    `DrawCurve(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.google.gwt.core.client.JavaScriptObject` | `create()`
    `DrawKnob` | `getC1Knob()` If this item is showing `KnobType.CONTROLPOINT1` `control knobs`, this attribute specifies the AutoChild for the `DrawKnob` for control point 1 of current drawCurve.
    `DrawKnob` | `getC2Knob()` If this item is showing `KnobType.CONTROLPOINT2` `control knobs`, this attribute specifies the AutoChild for the `DrawKnob` for control point 2 of current drawCurve.
    `Point` | `getCenter()` Get the center point of the rectangle from the curve's `startPoint` to the `endPoint`.
    `Point` | `getControlPoint1()` First cubic bezier control point.
    `Point` | `getControlPoint2()` Second cubic bezier control point.
    `Point` | `getEndPoint()` End point of the curve
    `KnobType[]` | `getKnobs()` Array of control knobs to display for this item.
    `LineCap` | `getLineCap()` Style of drawing the endpoints of a line.
    `static DrawCurve` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `boolean` | `getShowTitleLabelBackground()` If the `titleLabel` is showing, should the `titleLabelBackground` be created and placed behind the `titleLabel`?
    `Point` | `getStartPoint()` Start point of the curve
    `void` | `moveBy(int x, int y)` Increment start, end and control points of this curve
    `void` | `moveStartPointTo(java.lang.Integer x, java.lang.Integer y)` Move the start point, end point, and control points of the curve such that the `startPoint` ends up at the specified coordinates and the shape of the curve is unchanged.
    `void` | `setControlPoint1(Point controlPoint1)` First cubic bezier control point.
    `void` | `setControlPoint2(Point controlPoint2)` Second cubic bezier control point.
    `static void` | `setDefaultProperties(DrawCurve drawCurveProperties)` Class level method to set the default properties of this class.
    `void` | `setEndPoint(Point endPoint)` End point of the curve If this method is called after the component has been drawn/initialized: Update the endPoint
    `void` | `setKnobs(KnobType... knobs)` Array of control knobs to display for this item.
    `void` | `setLineCap(LineCap lineCap)` Style of drawing the endpoints of a line.
    `void` | `setShowTitleLabelBackground(boolean showTitleLabelBackground)` If the `titleLabel` is showing, should the `titleLabelBackground` be created and placed behind the `titleLabel`?
    `void` | `setStartPoint(Point startPoint)` Start point of the curve If this method is called after the component has been drawn/initialized: Update the startPoint

    - ### Methods inherited from class com.smartgwt.client.widgets.drawing.DrawItem

      `addClickHandler, addDragMoveHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseUpHandler, addMovedHandler, addResizedHandler, addShowContextMenuHandler, changeAutoChildDefaults, changeAutoChildDefaults, changeAutoChildDefaults, computeAngle, computeAngleAsDouble, dragResizeMove, draw, erase, getAttributeAsIntArray, getBoundingBox, getBoundingBoxAsDouble, getCanDrag, getCanHover, getCanvasAutoChild, getContextMenu, getCornerResizeKnob, getCursor, getDestroyed, getDestroying, getDragStartDistance, getDrawGroup, getDrawItemAutoChild, getDrawPane, getEditProxyConstructor, getEndArrow, getEndKnob, getEventOpaque, getFillColor, getFillGradient, getFillGradientAsString, getFillOpacity, getFormItemAutoChild, getHoverDelay, getHoverHTML, getKeepInParentRect, getLineColor, getLineOpacity, getLinePattern, getLineWidth, getMoveKnob, getMoveKnobOffset, getMoveKnobPoint, getPageLeft, getPageTop, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getRef, getResizeBoundingBox, getResizeBoundingBoxAsDouble, getResizeKnobPoints, getResizeOutline, getResizeViaLocalTransformOnly, getRotation, getRotationAsDouble, getScale, getShadow, getShowHover, getShowResizeOutline, getSideResizeKnob, getStartArrow, getStartKnob, getSvgString, getTitle, getTitleLabel, getTitleLabelBackground, getTitleLabelPadding, getTitleRotationMode, getTranslate, getXShearFactor, getYShearFactor, hide, hideAllKnobs, hideKnobs, hideKnobs, hover, isInBounds, isPointInPath, moveTo, resizeBy, resizeTo, rotateBy, rotateTo, scaleBy, scaleTo, setAttribute, setAttribute, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setCanDrag, setCanHover, setCenterPoint, setContextMenu, setCursor, setDefaultProperties, setDragStartDistance, setDrawGroup, setDrawPane, setEditProxyConstructor, setEndArrow, setEventOpaque, setFillColor, setFillGradient, setFillGradient, setFillOpacity, setHoverDelay, setKeepInParentRect, setKeepInParentRect, setLineColor, setLineOpacity, setLinePattern, setLineWidth, setMoveKnobOffset, setMoveKnobPoint, setPrompt, setPropertyValue, setProportionalResizeModifiers, setProportionalResizing, setResizeKnobPoints, setResizeViaLocalTransformOnly, setRotation, setRotation, setScale, setShadow, setShapeData, setShowHover, setShowResizeOutline, setStartArrow, setTitle, setTitleLabelPadding, setTitleRotationMode, setTranslate, setXShearFactor, setYShearFactor, show, showAllKnobs, showKnobs, showKnobs, supportsEndArrow, supportsStartArrow`

    - ### Methods inherited from class com.smartgwt.client.core.BaseClass

      `applyFactoryProperties, asSGWTComponent, createJsObj, destroy, doAddHandler, doInit, error, error, errorIfNotCreated, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsString, getAttributeAsStringArray, getClassName, getConfig, getHandlerCount, getID, getJsObj, getOrCreateJsObj, getScClassName, getTestInstance, hasAutoAssignedID, internalSetID, internalSetID, isConfigOnly, isCreated, isFactoryCreated, onBind, onInit, registerID, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setFactoryCreated, setID, setJavaScriptObject, setProperty, setProperty, setProperty, setProperty, setScClassName`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### DrawCurve

          public DrawCurve()

    - #### DrawCurve

          public DrawCurve(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static DrawCurve getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### create

          public com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `DrawItem`

    - #### getC1Knob

          public DrawKnob getC1Knob()
                             throws java.lang.IllegalStateException

      If this item is showing `KnobType.CONTROLPOINT1` `control knobs`, this attribute specifies the AutoChild for the `DrawKnob` for control point 1 of current drawCurve.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        DrawKnob
      Throws:
        `java.lang.IllegalStateException` - if the underlying component has not yet been created.

    - #### getC2Knob

          public DrawKnob getC2Knob()
                             throws java.lang.IllegalStateException

      If this item is showing `KnobType.CONTROLPOINT2` `control knobs`, this attribute specifies the AutoChild for the `DrawKnob` for control point 2 of current drawCurve.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        DrawKnob
      Throws:
        `java.lang.IllegalStateException` - if the underlying component has not yet been created.

    - #### setControlPoint1

          public void setControlPoint1(Point controlPoint1)

      First cubic bezier control point.
      If this method is called after the component has been drawn/initialized: Updates the first cubic Bézier control point.
      Parameters:
        `controlPoint1` - left coordinate for control point, in pixels. Default value is [100,0]

    - #### getControlPoint1

          public Point getControlPoint1()

      First cubic bezier control point.
      Returns:
        Point

    - #### setControlPoint2

          public void setControlPoint2(Point controlPoint2)

      Second cubic bezier control point.
      If this method is called after the component has been drawn/initialized: Updates the second cubic Bézier control point.
      Parameters:
        `controlPoint2` - left coordinate for control point, in pixels. Default value is [0,100]

    - #### getControlPoint2

          public Point getControlPoint2()

      Second cubic bezier control point.
      Returns:
        Point

    - #### setEndPoint

          public void setEndPoint(Point endPoint)

      End point of the curve
      If this method is called after the component has been drawn/initialized: Update the endPoint
      Parameters:
        `endPoint` - left coordinate for end point, in pixels. Default value is [100,100]

    - #### getEndPoint

          public Point getEndPoint()

      End point of the curve
      Returns:
        Point

    - #### setKnobs

          public void setKnobs(KnobType... knobs)
                        throws java.lang.IllegalStateException

      Array of control knobs to display for this item. Each `KnobType` specified in this will turn on UI element(s) allowing the user to manipulate this DrawCurve. To update the set of knobs at runtime use `DrawItem.showKnobs()` and `DrawItem.hideKnobs()`.

      DrawCurve supports the `KnobType.STARTPOINT`, `KnobType.ENDPOINT`, `KnobType.CONTROLPOINT1`, and `KnobType.CONTROLPOINT2` knob types.

      Overrides:
        `setKnobs` in class `DrawItem`
      Parameters:
        `knobs` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created
      See Also:
        `DrawItem.setKnobs(com.smartgwt.client.types.KnobType...)`

    - #### getKnobs

          public KnobType[] getKnobs()

      Array of control knobs to display for this item. Each `KnobType` specified in this will turn on UI element(s) allowing the user to manipulate this DrawCurve. To update the set of knobs at runtime use `DrawItem.showKnobs()` and `DrawItem.hideKnobs()`.

      DrawCurve supports the `KnobType.STARTPOINT`, `KnobType.ENDPOINT`, `KnobType.CONTROLPOINT1`, and `KnobType.CONTROLPOINT2` knob types.

      Overrides:
        `getKnobs` in class `DrawItem`
      Returns:
        KnobType...
      See Also:
        `DrawItem.getKnobs()`

    - #### setLineCap

          public void setLineCap(LineCap lineCap)

      Style of drawing the endpoints of a line.

      Note that for dashed and dotted lines, the lineCap style affects each dash or dot.

      Overrides:
        `setLineCap` in class `DrawItem`
      Parameters:
        `lineCap` - Default value is "butt"

    - #### getLineCap

          public LineCap getLineCap()

      Style of drawing the endpoints of a line.

      Note that for dashed and dotted lines, the lineCap style affects each dash or dot.

      Overrides:
        `getLineCap` in class `DrawItem`
      Returns:
        LineCap

    - #### setShowTitleLabelBackground

          public void setShowTitleLabelBackground(boolean showTitleLabelBackground)
                                           throws java.lang.IllegalStateException

      If the `titleLabel` is showing, should the `titleLabelBackground` be created and placed behind the `titleLabel`?

      This defaults to true for `DrawSector`s and shapes that are not commonly filled (e.g. `DrawLine`s).

      Note : This is an advanced setting

      Overrides:
        `setShowTitleLabelBackground` in class `DrawItem`
      Parameters:
        `showTitleLabelBackground` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getShowTitleLabelBackground

          public boolean getShowTitleLabelBackground()

      If the `titleLabel` is showing, should the `titleLabelBackground` be created and placed behind the `titleLabel`?

      This defaults to true for `DrawSector`s and shapes that are not commonly filled (e.g. `DrawLine`s).

      Overrides:
        `getShowTitleLabelBackground` in class `DrawItem`
      Returns:
        boolean

    - #### setStartPoint

          public void setStartPoint(Point startPoint)

      Start point of the curve
      If this method is called after the component has been drawn/initialized: Update the startPoint
      Parameters:
        `startPoint` - left coordinate for start point, in pixels. Default value is [0,0]

    - #### getStartPoint

          public Point getStartPoint()

      Start point of the curve
      Returns:
        Point

    - #### getCenter

          public Point getCenter()

      Get the center point of the rectangle from the curve's `startPoint` to the `endPoint`.
      Overrides:
        `getCenter` in class `DrawItem`
      Returns:
        the center point

    - #### moveBy

          public void moveBy(int x,
                             int y)

      Increment start, end and control points of this curve
      Overrides:
        `moveBy` in class `DrawItem`
      Parameters:
        `x` - new x coordinate in pixels
        `y` - new y coordinate in pixels

    - #### moveStartPointTo

          public void moveStartPointTo(java.lang.Integer x,
                                       java.lang.Integer y)

      Move the start point, end point, and control points of the curve such that the `startPoint` ends up at the specified coordinates and the shape of the curve is unchanged.
      Parameters:
        `x` - new x coordinate in pixels
        `y` - new y coordinate in pixels

    - #### setDefaultProperties

          public static void setDefaultProperties(DrawCurve drawCurveProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `drawCurveProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`